Quick Start for DOS 2.0 on the IBM PC

             Mike Cumming
      Winnipeg IBM PC Users Group

If you are using an IBM PC with DOS
2.0 and more than 64K memory and
don't want to wait for the BIOS RAM
check, the following will help. This
will work for both DOS 2.0 and DOS
2.1.

First, create a copy of your DOS
disk. Anytime you transfer the
system, use this modified disk. At
the DOS prompt, type DEBUG. At the
prompt, type:

-L CS:100 0 0 1 <CR> ;load the boot
                      record
-A 100 <CR>
XXXX:0100 JMP 282 <CR> ;jump to the
         modified portion of the boot
         record
XXXX:0103 <CR>
-A:282 <CR>
XXXX:0282 XOR AX,AX <CR> ;determine
         the amount of actual memory
XXXX:0284 OUT A0,AL <CR>
XXXX:0286 MOV BX,1000 <CR>
XXXX:0289 MOV ES,BX <CR>
XXXX:028B XOR DI,DI <CR>
XXXX:028D MOV CX,8000 <CR>
XXXX:0290 REPZ <CR>
XXXX:0291 STOSW <CR>
XXXX:0292 ES: <CR>
XXXX:0293 CMP [0000],AX <CR>
XXXX:0297 JNZ 2A3 <CR>
XXXX:0299 ADD BX,1000 <CR>
XXXX:029D CMP BX,A000 <CR>
XXXX:02A1 JNZ 289 <CR>
XXXX:02A3 MOV CL,06 <CR>
XXXX:02A5 SHR BX,CL <CR>
XXXX:02A7 MOV DS,AX <CR>
XXXX:02A9 MOV [413],BX <CR> ;store
         the total amount of memory
         in BIOS's address
XXXX:02AD MOV AL,80 <CR>
XXXX:02AF OUT A0,AL <CR>
XXXX:02B1 JMP 12E <CR> ;continue on
         as if nothing happened
XXXX:02B4 <CR>
-W CS:100 0 0 1 <CR> ;write out the
         modified boot record
-Q <CR>

These changes modify the boot record.
It should be used only on disks where
the system exists as it overlays the
DOS message "N on-system disk error,
replace, and strike any key when
ready". Next open the PC and set the
memory switches to 64K. Then insert
your modified DOS disk and boot up.

Notice the short wait!

To copy the modified boot record on
to existing disks which contain the
system, simply insert your modified
DOS disk and type:

L CS:100 0 0 1 <CR>  ;load the
               modified boot record

Now insert the disk you wish to add
the modified boot record to and type:

W CS:100 0 0 1 <CR>  ;write out the
                 modified boot record

and the disk will be modified.
