Installing Computer Chips

               Guy Pinte
      New York IBM PC Users Group

There are no real problems to
installing chips, just a little
common sense and care are all that is
required.

TURN OFF THE POWER.   Remove the PC
cover and any cards, but remember
which slots the cards were in.  An
installation tool is not required;
however a chip extractor, special
tweezers with hooks at the tips, is
highly recommended when removing
chips.

The three main problems encountered
are static electricity, broken pins,
and carelessness.

STATIC.   Do not wear synthetic
clothes or leather soled shoes. Work
and stand on newspaper. Discharge
yourself before beginning. Do not use
aluminum foil as a work surface!!

PINS.    The pins on most chips are
spread apart in too much of a "v"
shape to align easily with the socket
holes. You will probably need to
place the chip on its side and press
on it gently, bending the set of pins
resting on the table inward SLIGHTLY
to move them more near vertical. Do
this one chip at a time as you
install them into the sockets.

Each chip has a "U" shaped notch at
one end. This is important! This
notch should match up with a similar
mark on the socket or you may have to
use other chips of the same type as a
guide. Set each chip into its socket
GENTLY and push it firmly in with
both thumbs. Do not rush.

NEVER DISCONNECT A CABLE, INSTALL OR
PULL EITHER A CARD OR CHIP WITH THE
POWER ON!!!

After the chips are installed, you
will need to set the dip switches,
assuming you are adding memory chips.
There are two switch units on the PC
and one on the XT.  Positions 1-4 of
switch #2 reflects the total memory
of all the installed memory on the
PC. The single switch unit on the XT
reflects only the total on the system
board and does not deal with
expansion card memory.

Some switches 'slide' while others
'rock'. Consult the Guide to
Operations manual or expansion card
documentation for the proper switch
settings.

Note: Rocker settings are not always
intuitive. The active end is pushed
down (use a ball point pen). However,
some diagrams show the raised end of
the rocker as black. Black in this
case is the 'other end'. Confusing?
Beware of illustrations. Compare the
illustration for the pre-upgrade
settings to what you had before, this
will help you determine whether a
switch should be down or up in the
illustration.

Some expansion cards have switches to
'switch in' individual banks of
memory as needed. This should not be
confused with setting the starting
address of the card which is usually
equal to the amount of memory on the
system board. Some cards require to
be told the total memory on the card
itself.

Now, reinstall the cards, insert DOS
in drive A and turn on the power. It
will take longer than you are
accustomed to.


Run CHKDSK and note the total memory
at the bottom of the screen.  this
should be your new total memory. If
it is not, then the switches are set
incorrectly.

If the memory failed the diagnostic
and gave an error message on the
screen, you have a bad chip(s). This
is rare but it does happen. If you
have a special diagnostic that can
locate the chip use it.

The first step is to locate the row
of chips with the bad one(s).  POWER
OFF. Set the memory switches to the
next lower 64K and power on again. If
the diagnostic passes, then the bad
chip is in the last 64K. If it does
not pass, reduce the memory (by the
switches) by another 64K etc. until
the row harboring the culprit is
isolated.

Note: Since the XT switches do not
deal with expansion card memory and
therefore the total memory, a
different technique will have to be
used. If the card allows the
switching out of individual memory
banks, use them. Otherwise you may
have to remove chips a row at a time
until the fault goes away.

Once the row has been isolated, pull
a chip from a good row and set it
aside. Pull a chip from the bad row
and install it in the good row.
Repeat until you get a failure.
Remember when you pull and install
each chip Power Down first. There
could be more than one bad chip.

After you have tried all the chips
from the bad row and not found a bad
one, things may be okay. If a chip
was not fully seated, or if oxidation
has formed, an undeserved error may
point to a perfectly good chip. When
you moved the chip, you may have
corrected the fault when it was
reseated. Install the chips you
removed from the good row and install
them in the row that you removed all
the "suspect" chips from. Rerun the
diagnostics with all the memory
switched on again. If all goes well,
power off, button up, and enjoy.
