Focus on Word Proof

             George Gynn
    Northeast Indiana Users Group

After writing eighteen issues of a
user group newsletter, it takes a
pretty unusual piece of software to
get me excited, but Word Proof has!
You won't believe how good this is!
As you read this review, keep in
mind you're reading about a $60.00
list price from IBM.

Word Proof is something that
everyone who has a PC should have.
I think I'll be able to show you why
you shouldn't be without it,
regardless of what you do with your
PC.

Word Proof is all of the following:
1) the best, most powerful, and
fastest spelling checker on the
market, 2) an unbelievably good
synonym thesaurus, 3) a small but
easy to use word processor, and 4)
an anagram generator!

Word Proof is also provided with a
user customizing program that
couldn't be easier to use.  It
enables a user to customize almost
anything in the program including
special characters, default
parameters, screen colors, and
display parameters for all
components, even the lines around
menu boxes!

This program came with a good manual
that IBM and the authors can be
proud of.  The program is so good
and easy to use that the average PC
user could have got going without
the manual.  (Of course I think that
the average PC user is well above
average).


But enough hype, lets get on to what
you can expect with Word Proof.
Assume that you have made your
working copy, by copying both of the
two supplied disks to a single
double-sided disk.  Also assume that
you have a disk in drive B that
contains an ASCII file you have
written with your text editor or
with Word Proof.  Our final
assumption is that you have used the
'profile' menu and set the program
default values you want, such as
starting up in 80 column color.

Enter wp at the DOS prompt, and the
action begins.  A title page is
displayed and you press the space
bar.  Screen line 25 advises you
that it is reading the dictionary,
all 125,000 words.  About 8 seconds
later it's done! You are then
presented with the first menu.
Press 1 and it asks you for the
drive and filespec of the file to
proof.  Enter that information and
your text appears on the screen,
exactly as it is in its ASCII text
file.


Now, press F1 if you wish for a
quick look at the  F key options:

F1  help
F2  proof the whole file
F3  proof a word
F4  list synonyms
F5  find
F6  search
F7  insert line
F8  cursor to next word
F9  erase to end of line
F10  display the command menu

By pressing F2 a small window
appears where words being proofed
flash briefly at you.  When a
misspelled word is found, it stops
and the incorrect word is
highlighted in your text so you can
see the context, and another small
menu appears enabling you to select
by number whether you wish to:

1.  list possible spellings
2.  ignore the word and continue
3.  add the word to your auxiliary
    dictionary
4.  remember the word and stop the
    spelling check

Lets say that it stopped at the word
`thingx'.  If you pressed 1, it
reads the dictionary, and in a few
seconds another window appears that
provides a list of words that the
unknown word might be.  If your
correct word is there ('things'),
you use the arrow keys and move up
or down until things was
highlighted.  You would then press
enter and your text would be
instantly corrected.

But suppose that you would rather
use a word different than things
With the arrow keys, move the cursor
somewhere (anywhere) within the
word.  Press F4, and for a few
seconds WP reads a second
dictionary. Then another highlighted
menu appears, and there is a nice
list of synonyms of the word things
A list of 11 different words for you
to select from is shown.  Again,
using the arrow keys until you have
highlighted the word you want, press
enter, and the new word replaces the
old.


There is another feature, but it is
of limited use in my opinion, the
anagram list.  Press Alt+A, and it
searches the dictionary and gives a
list of anagrams of the word you
choose.  Good for Scrabble games I'm
sure.

Additional functions available in
the 'text editing' mode include
entering control characters like the
elusive DOS ESCape code.  You can
also change the left margin, set
page length, and insert page eject
characters.

The F1 help key displays a
succession of help screens, 5 in
total and cycles from the last one
back to the first one.  Sort of a
'lazy Susan' of help menus.  You can
save files specifying the drive and
file name you wish, or use the
default value, which you used when
you started the program.  Obviously
then, you can give an edited file a
new name if you wish.

After one look at the demo I bought
a copy.  The same day I showed it to
a friend's secretary.  She told him
if he wouldn't buy it, she would!
(He ordered it within the hour).  I
am not exaggerating, this is one of
the most useful, easy to use and
fastest running programs I have ever
seen.  Incidentally, I also used it
to proof a BASIC program file (saved
in ASCII, of course).
