Word Proof Review

             Jim Richter
   Silicon Valley Computer Society

This is a review of a spelling
checker with lots of nice features
called Word Proof.  It contains two
SSDD diskettes and the regular style
PC documentation.  One diskette
contains the program and dictionary
while the other contains a synonym
file.  It runs under PC DOS versions
1.0, 1.1, 2.0; with 96KB of memory;
and either a monochrome or color
display.  You need two diskette
drives, or equivalent, and a printer
if its full function is utilized.
The diskettes may be copied to a
backup diskette, an electronic disk
or a hard disk.

My usage of Word Proof has been with
standard ASCII text files.  The
documentation goes into good detail
about customizing for word processor
control word prefixes and
recognition characters.  The
dictionary size is in excess of
125,000 words, which is a real word
count, not some imaginary count
using prefix and suffix
concatenation.  It's amazing how
fast the dictionary search is.  I
had the program and dictionary on a
diskette and text file in RAM disk.
My test document had about 29,000
characters, 3250 words, and 680
unique words.  It took about 13
minutes to check and correct or
accept about 50 questionable words.
A second execution of Word Proof
with no errors took less than 3
minutes.  Acronyms and
colloquialisms give the most false
error conditions.  Any single
character is considered correct, as
are all numerics.

Everybody will have their own acid
test for a piece of software.  My
test for spelling checker is "What
happens to newmonia?". Word Proof
passed by finding pneumonia as the
first of six potential correct
spellings.  It's uncanny how the
search algorithm is able to find the
correct word if you get anywhere
close to it phonetically.  Sometimes
it is not the first word in the list
and sometime there are fewer than
six potential words.  If you are
about to buy a spelling checker, why
not take a document or two to your
software supplier for a live test.
You might consider inserting a few
known errors in the material.

The Word Proof manual has the
standard words in the first two
chapters about diskette care and
feeding. The "How to Use" lessons 1
through 7 are next and are nicely
done.  An equally fine reference
chapter follows.  The manual ends
with appendixes, a glossary, an
index, reference card, and function
key template to be cut out.  Some of
the documentation seems oriented
towards people who are trying to
write English as a third or fourth
language; for example on page 4-52
you will learn it is incorrect to
use "irregardless".  Other pages
have equally stimulating tidbits
from English 1.

The product was not hostile.  It
told me which drive was the current
default drive and let me change the
default.  I was able to display a
list of files on the default drive
and easily select one to process or
one to erase.  If an attempt was
made to write a file too large for a
diskette, a message and a gentle
beep permitted a diskette change.
Files can be renamed or can overlay
the input file.

It would be nice to be able to add
and delete words from the dictionary
and synonym list.  It is possible to
have a small auxiliary dictionary.
The synonym list is not modifiable.
Some other features not present are
a computer based introduction and
tutorial for the product, a count of
sentences, a count of words, a count
of unique words, a list of most
common words, and a grade level
index.

Word Proof also solves anagrams.  By
providing a string of letters, it
will return all possible words using
those letters.  This is probably a
by-product of the dictionary word
compression/compaction and search
techniques used.  It is amazing to
have less than 125,000 characters on
the diskette expanded into more than
125,000 correctly spelled words.

I feel this product has set a new
price performance standard for
spelling verification programs.  It
has the quality of doing the normal
and natural operations when the
standard keyboard control keys are
used.  I have yet to read the manual
from cover to cover and have not
found the reference card or function
key template necessary.

It is the new star in my software
library, after waiting three months
for delivery.  I have tried to be
fair and objective in my praise and
criticism of this product.  The
opinions expressed here are mine
alone and may or may not match your
experiences with this product in
your environment.
