The Modem Package

             Randy Wolpert
      Hawaii IBM PC Users' Group

As each day passes, home computers
become more and more a part of
everyday life. The novelty hasn't
worn off, but we now expect them to
do a lot more.  If you have any
doubts about this, just look at a
listing of the top selling software
for "home computers" now, and compare
it to the same type of list you might
have found just four or five years
ago.

I would like to address some of the
more frequently asked questions
regarding communications, and some of
the problems and choices that come up
when trying to find the "package"
that is right for you.

First and foremost, for those of you
who may not even know it, your
computer can be hooked up to the
phone. All that's needed (assuming
you already have a computer) is a
modem, and some software to use it.
The term modem comes from
"Modulate/Demodulate", which simply
means that once the two computers are
"talking to each other", the computer
that is doing the "talking"
(modulating) is sending characters
over the phone line, while the
computer at the other end is
"listening" (demodulating) to the
incoming characters that have been
sent.

If that's all there was to it,
choosing a modem would be a very
simple decision: get the least
expensive modem with the best
warranty and you're in
business...wrong!

The first decision you have to make
is probably the most important; do
you want an internal or external
modem? This is probably the biggest
stumbling block for prospective
buyers. There are good and bad points
for either type. First let me explain
the differences between the two.
Assuming, for the sake of argument,
both types will do the same functions
when it comes to actual
"communication".

An INTERNAL modem goes right inside
your computer and you won't even know
it's there. You don't need more on
that already cluttered desk of yours.
With an internal modem, all you have
to do is plug it into the wall outlet
using a simple phone cord, and you're
ready to go.  There aren't any other
cables to attach as there are with
external modems. You don't have to
purchase a separate card that has a
serial port on it because the modem
has not one, but two built in. You
can use the other connection to run a
mouse or serial printer or whatever
other serial device you choose. You
have the ability to put 256K on the
mother board and you don't need any
more than that to run your
applications. You have a printer port
on your monochrome display, and now
you will have two serial ports. Why
spend all that extra money on a
multifunction board for just a clock
now that you have all of the
essentials?

An EXTERNAL modem, because you are
almost out of slots in your PC. Why
waste that last slot when you already
have a multifunction board that has
the connection for serial device such
as a modem?  With an external modem,
you can "see" what is happening
because it has lights that keep you
informed as to what's going on. There
will be less heat build up in your
unit, and if you're not careful,
choosing the wrong internal modem may
require that the slot next to it be
vacant to accommodate its width. You
can also change the volume level on
it because the knob for this
adjustment is right on the modem.
Since you change the way you use your
modem so often, changing the switches
for different applications is much
easier. If you only use your modem
once in a while, you can leave it off
because it has a separate power
supply.  One other thing to think
about is you can easily move it from
one computer to another just by
unplugging it.

The only other big decision is
choosing what baud rate you want, or
can afford. The term baud rate is
simply a way of expressing the speed
at which the modem can communicate
with the computer at the other end of
the line. A 300 baud modem can
transmit and receive 30 characters
per second and is roughly $250 -
$300. A 1200 baud modem can do the
same at 120 cps and sells for between
$500 - $700. The prices vary, but
this will give you a rough idea of
what you are in for. The old saying
"A chain is only as strong as its
weakest link" also applies to modems.
If you communicate with modems that
are restricted to 300 baud, it
doesn't matter how fast and fancy
your modem is, it's going to look and
operate like a 300 baud modem. If on
the other hand, you can take
advantage of the higher speeds
because the service or whoever you
call has the capability of 1200 baud,
then you should consider the higher
priced, faster modems. Just a note:
most of the "information" services
available charge a higher rate per
hour at the higher baud rate, and
although it is not four times more,
it is something to remember.

Now, my personal thoughts. It used to
be quite a feature if a modem could
"pick up the phone, dial the number,
wait for an answer, then give you
control".  Now that is expected in a
modem. We also expect it to be able
to automatically answer the phone on
the first ring. In order for a modem
to take full advantage of the
software programs available, I think
this is a must. Stay away from modems
that require you to dial.

Another question to have answered is
"Does the modem have a speaker built
in?".  I would not consider one that
didn't, especially the internal
modems. An internal modem without a
speaker provides you with no way of
"monitoring" your call, except
watching the screen. With the
built-in speaker, you can monitor
your call up to its time of
connection. If you dial time you can
even find out what the exact time is
by listening in on the call. The main
reason for a speaker is to learn if
you have a dial tone, if the call is
placed, and if another computer
answers. Then the speaker, unless we
tell it not to, will go silent and
normal communications begin.

One last thing to consider. Try to
have a demo on any software packaged
with the modem. There are many good
programs available, and each type has
its strong points so make Joe earn
his keep. Have him show you the
auto-dialing directory, the scrolling
and searching through previously
captured information, the file upload
and download capabilities, and any
other features that may accompany the
software package. In general, if you
buy software separate from a modem
(even the best ones come without
software), make sure the two
compliment each other so you get the
most out of your purchase.
